'****************************************************************************
'
'  PowerBASIC April April Upload-CGI  :-)
'
'  (c) 2005-2007 Thomas Gohel, Alle Rechte vorbehalten
'
'****************************************************************************

$COMPILE EXE                             ' als EXE-Files kompilieren
$DIM ALL                                 ' alle Variablenm mssen deklariert werden
$INCLUDE "PBCGI2.INC"

GLOBAL Version        AS STRING
GLOBAL Autor          AS STRING
GLOBAL Copyright      AS STRING
GLOBAL ContentId      AS STRING

DECLARE FUNCTION PBCompileFile(BYVAL FormData AS STRING, Filenamen AS STRING, PBCompiler AS STRING) AS LONG

DECLARE FUNCTION CgiReport(BYVAL Result AS LONG, Filenamen AS STRING, PBCompiler AS STRING) AS LONG
DECLARE FUNCTION Get_Formstring(BYVAL MimeBlock AS STRING, c1 AS LONG, c2 AS LONG, BYVAL Steps AS LONG) AS STRING
DECLARE FUNCTION GetCRC32(BYVAL Buffer AS STRING) AS STRING


'****************************************************************************
'  Routine zum bermitteln und zur automatischen Erstellung des TIC-Files
'****************************************************************************
FUNCTION PBCompileSource() AS LONG

        LOCAL FormData     AS STRING
        LOCAL FileNamen    AS STRING
        LOCAL PBCompiler   AS STRING

        FormData$ = webdataStdIn
        CgiReport(PBCompileFile(Formdata$, FileNamen$, PBCompiler$), Filenamen$, PBCompiler$)
        FUNCTION = 0

END FUNCTION

FUNCTION PBCompileFile(BYVAL FormData AS STRING, FileNamen AS STRING, PBCompiler AS STRING) AS LONG

        LOCAL MimeIdent    AS STRING
        LOCAL MimeIdentLen AS LONG
        LOCAL MimeCount    AS LONG
        LOCAL MimeBlock    AS STRING
        LOCAL FormName     AS STRING
        LOCAL FormEncId    AS STRING
        LOCAL FormContent  AS STRING
        LOCAL FileConttype AS STRING
        LOCAL FileDesc     AS STRING
        LOCAL PBSource     AS STRING
        LOCAL PBAuthor     AS STRING * 25
        LOCAL PBEmail      AS STRING
        LOCAL PBFile       AS STRING
        LOCAL hFile        AS LONG
        LOCAL hApril       AS LONG
        LOCAL p1           AS LONG
        LOCAL p2           AS LONG
        LOCAL c1           AS LONG
        LOCAL c2           AS LONG
        LOCAL f            AS LONG
        LOCAL Content      AS STRING
        LOCAL ContentType  AS LONG
        LOCAL i            AS LONG
        LOCAL Temp         AS STRING
        LOCAL Fehler       AS LONG

        FUNCTION = 0   '   0 = Upload successfull
                       '   1 = no filename given
                       '   2 = filename already exists
                       '   3 = no description
                       '   4 = description to short

        ContentType = 0

'        p1 = INSTR(FormData, $CRLF) - 2
        MimeIdent = LEFT$(FormData$, INSTR(FormData$, $CRLF) - 1)       ' Blockkkenner ermitteln
        MimeCount = TALLY(FormData$, MimeIdent) - 1
        MimeIdentLen = LEN(MimeIdent)

        p1 = MimeIdentLen + 3
        FOR i& = 1 TO MimeCount
            p2 = INSTR(p1, FormData, MimeIdent) + MimeIdentLen
            MimeBlock = MID$(FormData, p1, (p2 - p1) - MimeIdentLen)
            '? MimeBlock
            c1& = 1
            DO
                c2& = INSTR(c1&, MimeBlock, $CRLF)
                Content = MID$(MimeBlock, c1&, c2& - c1&)

                IF LEFT$(Content, 20) = "Content-Disposition:" THEN
                    Formname = MID$(TRIM$(PARSE$(Content, ";", 2)), 7)
                    Formname = LEFT$(Formname, LEN(Formname) - 1)
                    SELECT CASE Formname
                        CASE "pbfile"

                            ' Filenamen ermitteln und Pfad abschneiden (IE-Bug)
                            Filenamen = MID$(TRIM$(PARSE$(Content, ";", 3)), 11)
                            Filenamen = LEFT$(Filenamen, LEN(Filenamen) - 1)
                            f = PARSECOUNT(Filenamen, "\")
                            Filenamen = PARSE$(Filenamen, "\", f)

                            ' Content-Type Header auslesen
                            FileContType = Get_Formstring(MimeBlock, c1, c2, 2)
                            IF LEFT$(FileContType, 13) = "Content-Type:" THEN
                                FormEncId = MID$(FileContType, 15)
                                ContentId = FormEncId
                                SELECT CASE LCASE$(FormEncId)
                                    CASE "application/octet-stream"
                                        ContentType = 0
                                    CASE "application/zip"
                                        ContentType = 0
                                END SELECT
                            END IF

                            ' Content bzw. File auslesen
                            c1& = c2& + 4
                            FormContent = MID$(MimeBlock, c1&)
                            FormContent = LEFT$(FormContent, LEN(FormContent) - 2)

                        CASE "desc"
                            FileDesc = Get_Formstring(MimeBlock, c1, c2, 4)
                        CASE "pbsource"
                            c1& = c2& + 4
                            PBSource = MID$(MimeBlock, c1&)
                            PBSource = LEFT$(PBSource, LEN(PBSource) - 2)
                        CASE "pbcompiler"
                            PBCompiler = Get_Formstring(MimeBlock, c1, c2, 4)
                            'PBCompiler = PARSE$(PBCompiler, ":", 1)
                        CASE "pbauthor"
                            PBAuthor = Get_Formstring(MimeBlock, c1, c2, 4)
                        CASE "pbemail"
                            PBEmail  = Get_Formstring(MimeBlock, c1, c2, 4)
                    END SELECT
                END IF
                c1& = c2& + 2
            LOOP WHILE NOT LEN(Content) = 0
            p1 = p2 + 2
        NEXT i&

        ' Auswerten und Ablegen im Upload-Verzeichnis
        IF ContentType > 0 THEN
            Fehler = ContentType
        END IF

        PBAuthor$ = TRIM$(PBAuthor$)
        PBEmail$  = TRIM$(PBEmail$)

        IF LEN(PBAuthor$) < 10 OR INSTR(PBAuthor, " ") = 0 THEN
            FUNCTION = 10
            EXIT FUNCTION
        END IF
        IF LEN(PBEmail$) < 10 OR INSTR(PBEmail$, "@") = 0 THEN
            FUNCTION = 11
            EXIT FUNCTION
        END IF

        ' So, jetzt ein paar sinnlose Fehler einbauen , hhh ;-)
        Temp$ = LCASE$(PBSource)

        ' PowerBASIC /DOS
        IF INSTR(LCASE$(PBCompiler), "/dos") > 0 THEN
            IF INSTR(Temp$, "$compile exe") = 0 THEN
               Fehler = 100
            END IF
            IF INSTR(Temp$, "$lib") = 0 THEN
               Fehler = 101
            END IF
        END IF

        ' PowerBASIC/CC & PowerBASIC/Win
        IF INSTR(LCASE$(PBCompiler), "/cc") > 0 OR INSTR(LCASE$(PBCompiler), "/win") > 0 THEN
            IF INSTR(Temp$, "#compile exe") = 0 THEN
               Fehler = 200
            END IF
            IF INSTR(Temp$, "#include " & $DQ & "win32api.inc" & $DQ) = 0 THEN
               Fehler = 201
            END IF
            IF INSTR(Temp$, "pbmain") = 0 THEN
               Fehler = 202
            END IF
            IF INSTR(Temp$, "end function") = 0 THEN
               Fehler = 203
            END IF
        END IF

        ' PowerBASIC/Linux
        IF INSTR(LCASE$(PBCompiler), "/linux") > 0 THEN
            Fehler = 399
            IF INSTR(Temp$, "#compile exe") = 0 THEN
               Fehler = 300
            END IF
            IF INSTR(Temp$, "pbmain") = 0 THEN
               Fehler = 302
            END IF
            IF INSTR(Temp$, "end function") = 0 THEN
               Fehler = 303
            END IF
        END IF

        ' Das richtige April-File verwenden ;-)
        IF INSTR(LCASE$(PBCompiler), "/dos") > 0 THEN
            PBFile = "AprilDOS.EXE"
        END IF
        IF INSTR(LCASE$(PBCompiler), "/cc") > 0 THEN
            PBFile = "AprilCC.EXE"
        END IF
        IF INSTR(LCASE$(PBCompiler), "/win") > 0 THEN
            PBFile = "AprilWin.EXE"
        END IF
        IF INSTR(LCASE$(PBCompiler), "/linux") > 0 THEN
            PBFile = "AprilDOS.EXE"
        END IF

        FileNamen = GetCrc32(PBSource & PBCompiler) + ".exe.bin"

        ' Online-File erstellen, jojo 8-)

        IF Fehler = 0 THEN
            hFile = FREEFILE
            OPEN ".......\PBOC\" + PBFile$ FOR BINARY LOCK READ WRITE AS #hFile
                hApril = FREEFILE
                OPEN ".......\PBOC\files\" + Filenamen$ FOR BINARY LOCK READ WRITE AS #hApril
                    GET$ #hFile, 32000, Temp$
                    REPLACE "AprilAprilAprilAprilApril" WITH PBAuthor$ IN Temp$
                    PUT$ #hApril, Temp$
                    SETEOF(hApril)
                CLOSE #hApril
            CLOSE #hFile
        END IF

        IF Fehler < 400 THEN
            ' April-EXE erstellen
            hApril = FREEFILE
            OPEN ".......\PBOC\files\" + Filenamen$ + ".tic" FOR OUTPUT LOCK READ WRITE AS #hApril
                PRINT #hApril, "pbauthor  : " + PBAuthor$
                PRINT #hApril, "pbmail    : " + PBEmail$
                PRINT #hApril, "pbcompiler: " + PBCompiler$
                PRINT #hApril, "pbsource  : " + $CRLF + $CRLF + PBsource$
                SETEOF(hApril)
            CLOSE #hFile
            hApril = FREEFILE
            OPEN ".......\PBOC\pbcompiler.log" FOR OUTPUT LOCK READ WRITE AS #hApril
                PRINT #hApril, "-----------------------------------------------------------------------------"
                PRINT #hApril, DATE$ & "-" & TIME$ & "  " & Remote_Addr
                PRINT #hApril, "     " & Http_User_Agent
                PRINT #hApril, "     " & Http_Accept_Language
                PRINT #hApril, "     " & PBCompiler$
            CLOSE #hApril
            FUNCTION = Fehler
        ELSE
            FUNCTION = Fehler
        END IF

END FUNCTION

FUNCTION CgiReport(BYVAL Result AS LONG, Filenamen AS STRING, PBCompiler AS STRING ) AS LONG

        LOCAL hHtml        AS LONG
        LOCAL HtmlPage     AS STRING
        LOCAL HtmlPage1    AS STRING
        LOCAL HtmlPage2    AS STRING
        LOCAL HtmlPage3    AS STRING
        LOCAL p1           AS LONG
        LOCAL p2           AS LONG

        hHtml = FREEFILE

        OPEN ".......\pboc\index.html" FOR BINARY AS #hHtml
            GET$ #hHtml, LOF(hHtml), Htmlpage

            p1 = INSTR(1, Htmlpage, "<!--#if expr=")
            p2 = INSTR(p1, HtmlPage, "<!--#endif -->")

            HtmlPage1 = LEFT$(Htmlpage, p1-1)
            HtmlPage3 = MID$(HtmlPage, p2 + 14)

            SELECT CASE Result
                CASE 0
                     HtmlPage2 = "Congratulation! Your PowerBASIC file has been successfull compiled with " & PBCompiler$ & ".<br><br><br>" & _
                                 "You can download the file with the following link:<br><br>" + _
                                 "<a href=http://www.pbhq.com/pboc/files/" & Filenamen$ & ">" & Filenamen$ & "</a>&nbsp;&nbsp;&nbsp;&nbsp;Please remove " & _
                                 $DQ & ".bin" & $DQ & " after the download, it's for your security.<br><br><br>" & _
                                 "Note: These file is available til 01.04.2007 - 23:59, thank you. :-)<br><br>" + _
                                 "<br><br><br><br><br>" & _
                                 "<span class=" & $DQ & "footer_copy_font" & $DQ& ">" & _
                                 "IP logged : " & Remote_Addr & "<br>" & _
                                 "User-Agent: " & Http_User_Agent & "<br>" & _
                                 "Language  : " & Http_Accept_Language & "<br>" & _
                                 "</span>"
                CASE 10
                     HtmlPage2 = "Realname missing or invalid, sorry"
                CASE 11
                     HtmlPage2 = "EMail address missing or invaild , sorry"
                CASE 100
                     HtmlPage2 = "Compiler Error: $compile missing"
                CASE 101
                     HtmlPage2 = "Compiler Error: $lib missing"
                CASE 200
                     HtmlPage2 = "Compiler Error: #compile missing"
                CASE 201
                     HtmlPage2 = "Compiler Error: #include " & $DQ & "win32api.inc" & $DQ & " missing"
                CASE 202
                     HtmlPage2 = "Compiler Error: Executable required PBMAIN/WinMain function"
                CASE 203
                     HtmlPage2 = "Compiler Error 519: END FUNCTION missing"
                CASE 300
                     HtmlPage2 = "Compiler Error: #compile missing"
                CASE 302
                     HtmlPage2 = "Compiler Error: Executable required PBMAIN/LinuxMain function"
                CASE 303
                     HtmlPage2 = "Compiler Error 519: END FUNCTION missing"
                CASE 399
                     HtmlPage2 = "Compiler Error: Executable required GTX+ 1.2"
                CASE ELSE
                     HtmlPage2 = "Unknown error, please compile the source with your own PowerBASIC compiler, sorry"
            END SELECT

            ' Errors in andere Farbe darstellen
            IF Result = 0 THEN
                'HtmlPage2 = "<font face=" & $DQ & "Verdana,Arial" & $DQ & " size=" & $DQ & "2" & $DQ & " color=" & $DQ & "blue" & $DQ & ">" + _
                '            "<b><i>" & HtmlPage2 & "</i></b>" + _
                '            "</font>"
                HtmlPage2 = "<span style=" & $DQ & "font-family: Verdana, Arial; font-size:12px; font-weight:bold; font-style:italic; " + _
                            "color:navy"     & $DQ & ">" & HtmlPage2 & "</span>"
            ELSE
                'HtmlPage2 = "<font face=" & $DQ & "Verdana,Arial" & $DQ & " size=" & $DQ & "2" & $DQ & " color=" & $DQ & "red" & $DQ & ">" + _
                '            "<b><i>" & HtmlPage2 & "</i></b>" + _
                '            "</font>"
                HtmlPage2 = "<span style=" & $DQ & "font-family: Verdana, Arial; font-size:12px; font-weight:bold; font-style:italic; " + _
                             "color:#DD0000" & $DQ & ">" & HtmlPage2 & "</span>"
            END IF

            WriteCgi(Htmlpage1 & HtmlPage2 & "<br><br>" & HtmlPage3)

        CLOSE hHtml

END FUNCTION


FUNCTION Get_Formstring(BYVAL MimeBlock AS STRING, c1 AS LONG, c2 AS LONG, BYVAL Steps AS LONG) AS STRING

        c1& = c2& + Steps
        c2& = INSTR(c1&, MimeBlock, $CRLF)
        FUNCTION = MID$(MimeBlock, c1&, c2& - c1&)

END FUNCTION


'=============================================================================
'
'  CRC32 - Calculate a CCITT 32-bit for a buffer
'  Copyright (c) 1998 by PowerBASIC, Inc.
'
'  This source will compile unmodified in PB/CC.  The Crc32 function itself
'  is compatible with PB/DLL 5.0.
'
'=============================================================================

FUNCTION Crc32(BYVAL Address AS DWORD, _
               BYVAL Length AS LONG, _
               BYVAL Seed AS LONG) AS LONG

  ! push    EBX                     ; save EBX for PowerBASIC
  ! mov     EDI,Address             ; address in EDI
  ! mov     ECX,Length              ; length in ECX
  ! jecxz   CrcDone                 ; exit is zero length
  ! cld                             ; clear the direction flag

BuildCRC:
  ! movzx   EBX, Byte Ptr [EDI]     ; get a char
  ! mov     AX, Seed[1]             ; get 2nd and 3rd bytes of seed
  ! xor     DX, DX                  ; clear DX
  ! mov     DL, Seed[3]             ; get 4th byte of seed
  ! xor     BL, Seed[0]             ; xor char against first byte of seed
  ! xor     BH, BH                  ; clear BH
  ! shl     BX, 2                   ; shift the index
  ! xor     AX, CrcTable[EBX]       ; xor low-half against the table
  ! xor     DX, CrcTable[EBX+2]     ; xor high-half against the table
  ! mov     Seed[0], AX             ; save the result
  ! mov     Seed[2], DX             ;   ...
  ! inc     EDI                     ; move to next char
  ! loop    BuildCRC                ; do ECX times

CrcDone:
  ! pop     EBX                     ; restore EBX

  FUNCTION = Seed

  EXIT FUNCTION

CrcTable:
  ! dd &H000000000&, &H077073096&, &H0EE0E612C&, &H0990951BA&
  ! dd &H0076DC419&, &H0706AF48F&, &H0E963A535&, &H09E6495A3&
  ! dd &H00EDB8832&, &H079DCB8A4&, &H0E0D5E91E&, &H097D2D988&
  ! dd &H009B64C2B&, &H07EB17CBD&, &H0E7B82D07&, &H090BF1D91&
  ! dd &H01DB71064&, &H06AB020F2&, &H0F3B97148&, &H084BE41DE&
  ! dd &H01ADAD47D&, &H06DDDE4EB&, &H0F4D4B551&, &H083D385C7&
  ! dd &H0136C9856&, &H0646BA8C0&, &H0FD62F97A&, &H08A65C9EC&
  ! dd &H014015C4F&, &H063066CD9&, &H0FA0F3D63&, &H08D080DF5&
  ! dd &H03B6E20C8&, &H04C69105E&, &H0D56041E4&, &H0A2677172&
  ! dd &H03C03E4D1&, &H04B04D447&, &H0D20D85FD&, &H0A50AB56B&
  ! dd &H035B5A8FA&, &H042B2986C&, &H0DBBBC9D6&, &H0ACBCF940&
  ! dd &H032D86CE3&, &H045DF5C75&, &H0DCD60DCF&, &H0ABD13D59&
  ! dd &H026D930AC&, &H051DE003A&, &H0C8D75180&, &H0BFD06116&
  ! dd &H021B4F4B5&, &H056B3C423&, &H0CFBA9599&, &H0B8BDA50F&
  ! dd &H02802B89E&, &H05F058808&, &H0C60CD9B2&, &H0B10BE924&
  ! dd &H02F6F7C87&, &H058684C11&, &H0C1611DAB&, &H0B6662D3D&
  ! dd &H076DC4190&, &H001DB7106&, &H098D220BC&, &H0EFD5102A&
  ! dd &H071B18589&, &H006B6B51F&, &H09FBFE4A5&, &H0E8B8D433&
  ! dd &H07807C9A2&, &H00F00F934&, &H09609A88E&, &H0E10E9818&
  ! dd &H07F6A0DBB&, &H0086D3D2D&, &H091646C97&, &H0E6635C01&
  ! dd &H06B6B51F4&, &H01C6C6162&, &H0856530D8&, &H0F262004E&
  ! dd &H06C0695ED&, &H01B01A57B&, &H08208F4C1&, &H0F50FC457&
  ! dd &H065B0D9C6&, &H012B7E950&, &H08BBEB8EA&, &H0FCB9887C&
  ! dd &H062DD1DDF&, &H015DA2D49&, &H08CD37CF3&, &H0FBD44C65&
  ! dd &H04DB26158&, &H03AB551CE&, &H0A3BC0074&, &H0D4BB30E2&
  ! dd &H04ADFA541&, &H03DD895D7&, &H0A4D1C46D&, &H0D3D6F4FB&
  ! dd &H04369E96A&, &H0346ED9FC&, &H0AD678846&, &H0DA60B8D0&
  ! dd &H044042D73&, &H033031DE5&, &H0AA0A4C5F&, &H0DD0D7CC9&
  ! dd &H05005713C&, &H0270241AA&, &H0BE0B1010&, &H0C90C2086&
  ! dd &H05768B525&, &H0206F85B3&, &H0B966D409&, &H0CE61E49F&
  ! dd &H05EDEF90E&, &H029D9C998&, &H0B0D09822&, &H0C7D7A8B4&
  ! dd &H059B33D17&, &H02EB40D81&, &H0B7BD5C3B&, &H0C0BA6CAD&
  ! dd &H0EDB88320&, &H09ABFB3B6&, &H003B6E20C&, &H074B1D29A&
  ! dd &H0EAD54739&, &H09DD277AF&, &H004DB2615&, &H073DC1683&
  ! dd &H0E3630B12&, &H094643B84&, &H00D6D6A3E&, &H07A6A5AA8&
  ! dd &H0E40ECF0B&, &H09309FF9D&, &H00A00AE27&, &H07D079EB1&
  ! dd &H0F00F9344&, &H08708A3D2&, &H01E01F268&, &H06906C2FE&
  ! dd &H0F762575D&, &H0806567CB&, &H0196C3671&, &H06E6B06E7&
  ! dd &H0FED41B76&, &H089D32BE0&, &H010DA7A5A&, &H067DD4ACC&
  ! dd &H0F9B9DF6F&, &H08EBEEFF9&, &H017B7BE43&, &H060B08ED5&
  ! dd &H0D6D6A3E8&, &H0A1D1937E&, &H038D8C2C4&, &H04FDFF252&
  ! dd &H0D1BB67F1&, &H0A6BC5767&, &H03FB506DD&, &H048B2364B&
  ! dd &H0D80D2BDA&, &H0AF0A1B4C&, &H036034AF6&, &H041047A60&
  ! dd &H0DF60EFC3&, &H0A867DF55&, &H0316E8EEF&, &H04669BE79&
  ! dd &H0CB61B38C&, &H0BC66831A&, &H0256FD2A0&, &H05268E236&
  ! dd &H0CC0C7795&, &H0BB0B4703&, &H0220216B9&, &H05505262F&
  ! dd &H0C5BA3BBE&, &H0B2BD0B28&, &H02BB45A92&, &H05CB36A04&
  ! dd &H0C2D7FFA7&, &H0B5D0CF31&, &H02CD99E8B&, &H05BDEAE1D&
  ! dd &H09B64C2B0&, &H0EC63F226&, &H0756AA39C&, &H0026D930A&
  ! dd &H09C0906A9&, &H0EB0E363F&, &H072076785&, &H005005713&
  ! dd &H095BF4A82&, &H0E2B87A14&, &H07BB12BAE&, &H00CB61B38&
  ! dd &H092D28E9B&, &H0E5D5BE0D&, &H07CDCEFB7&, &H00BDBDF21&
  ! dd &H086D3D2D4&, &H0F1D4E242&, &H068DDB3F8&, &H01FDA836E&
  ! dd &H081BE16CD&, &H0F6B9265B&, &H06FB077E1&, &H018B74777&
  ! dd &H088085AE6&, &H0FF0F6A70&, &H066063BCA&, &H011010B5C&
  ! dd &H08F659EFF&, &H0F862AE69&, &H0616BFFD3&, &H0166CCF45&
  ! dd &H0A00AE278&, &H0D70DD2EE&, &H04E048354&, &H03903B3C2&
  ! dd &H0A7672661&, &H0D06016F7&, &H04969474D&, &H03E6E77DB&
  ! dd &H0AED16A4A&, &H0D9D65ADC&, &H040DF0B66&, &H037D83BF0&
  ! dd &H0A9BCAE53&, &H0DEBB9EC5&, &H047B2CF7F&, &H030B5FFE9&
  ! dd &H0BDBDF21C&, &H0CABAC28A&, &H053B39330&, &H024B4A3A6&
  ! dd &H0BAD03605&, &H0CDD70693&, &H054DE5729&, &H023D967BF&
  ! dd &H0B3667A2E&, &H0C4614AB8&, &H05D681B02&, &H02A6F2B94&
  ! dd &H0B40BBE37&, &H0C30C8EA1&, &H05A05DF1B&, &H02D02EF8D&

END FUNCTION

FUNCTION GetCRC32(BYVAL Buffer AS STRING) AS STRING

        LOCAL Crc      AS LONG
        Crc = Crc32(STRPTR(Buffer), LEN(Buffer), -1)
        Crc = Crc XOR -1&  'compute PKZIP/ZMODEM compatible CRC result

        FUNCTION = HEX$(Crc, 8)

END FUNCTION

'**************************************************************************
'   Kommandozeilen-Utilities
'**************************************************************************

FUNCTION PBMAIN() AS LONG

        LOCAL Result       AS LONG
        DIM   Param(1)     AS STRING

        Version$      = "0.10"                      ' Version
        Autor$        = "Thomas Gohel"              ' Copyright, der Programmierer
        Copyright$    = "PB Online Compiler Cgi-Edition v" + Version$ + " - (c) 2005-2007 by " + Autor$

        PBCompileSource

END FUNCTION
